package com.tumblr.login;

import java.io.IOException;
import java.net.URLEncoder;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import oauth.signpost.OAuthConsumer;
import oauth.signpost.OAuthProvider;
import oauth.signpost.basic.DefaultOAuthConsumer;
import oauth.signpost.basic.DefaultOAuthProvider;

public class LoginServlet extends HttpServlet {
    private static final long serialVersionUID = 1L;
    
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    	String callbackURL = null;
        
        try {
        	
            StringBuffer callbackURLbuffer = request.getRequestURL();
            int index = callbackURLbuffer.lastIndexOf("/");
            callbackURLbuffer.replace(index, callbackURLbuffer.length(), "").append("/callback");
            callbackURL = URLEncoder.encode(callbackURLbuffer.toString(), "UTF-8");
        	
        	String tumblrConsumerKey = getServletContext().getInitParameter("tumblrConsumerKey");
        	String tumblrSecretKey = getServletContext().getInitParameter("tumblrSecretKey");

            
            
        	OAuthConsumer consumer = new DefaultOAuthConsumer(tumblrConsumerKey,tumblrSecretKey);
        	
        	// create a new service provider object and configure it with
            // the URLs which provide request tokens, access tokens, and
            // the URL to which users are sent in order to grant permission
            // to your application to access protected resources
            OAuthProvider provider = new DefaultOAuthProvider(
                    "http://www.tumblr.com/oauth/request_token", 
                    "http://www.tumblr.com/oauth/access_token",
                    "http://www.tumblr.com/oauth/authorize");

            // fetches a request token from the service provider and builds
            // a url based on AUTHORIZE_WEBSITE_URL and CALLBACK_URL to
            // which your app must now send the user
            String url = provider.retrieveRequestToken(consumer, callbackURL);
            System.out.println("url: "+url);
            
            HttpSession httpSession = request.getSession();
            httpSession.setAttribute("consumer", consumer);
            httpSession.setAttribute("provider", provider);
            response.sendRedirect(url);

        } catch (Exception e) {
            throw new ServletException(e);
        }

    }
}
